package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	
	/**
	 * ...
	 * @author Keith Weatherby II
	 * This doesn't even have a proper title but here is the LD 0 "Indirect Interaction"
	 * Catch-up game.  This is most of the player stuff, which really doesn't do a lot
	 * Source code copyright 2011 by Keith Weatherby II
	 * License: Use as you see fit.
	 */
	public class Player extends Entity 
	{
		[Embed(source = 'img/raft.png')] private const PLAYER:Class;
		[Embed(source = 'img/cloudleft.png')] private const LEFT_CLOUD:Class;
		[Embed(source = 'img/cloudright.png')] private const RIGHT_CLOUD:Class;
		[Embed(source = 'img/blowleft.png')] private const LEFT_BLOW:Class;
		[Embed(source = 'img/blowright.png')] private const RIGHT_BLOW:Class;
		
		public var xVel:Number = 0;
		public var xAccel:Number = 200;
		public var yAccel:Number = 10;

		public var leftCloud:Entity;
		public var rightCloud:Entity;
		public var leftBlow:Entity;
		public var rightBlow:Entity;
		
		public var state:String;
		public var yVel:Number = 0;
		public var yInc:Number = 0;

		public var score:int = 0;
		
		public function Player() 
		{
			graphic = new Image(PLAYER);
			leftCloud = new Entity(16, 16, new Image(LEFT_CLOUD));
			rightCloud = new Entity(FP.screen.width - 64 - 16, 16, new Image(RIGHT_CLOUD));
			leftBlow = new Entity(FP.screen.width - 64 - 16 - 32, 16, new Image(LEFT_BLOW));
			rightBlow = new Entity(80, 16, new Image(RIGHT_BLOW));
			leftBlow.visible = false;
			rightBlow.visible = false;
			InitPlayer();
		}
		
		public function InitPlayer():void
		{
			x = (FP.screen.width - 8) / 2;
			y = 24;
			width = 8;
			height = 16;
			xVel = 0;
			yVel = 0;
			state = "ready";
			leftCloud.y = 16;
			rightCloud.y = 16;
			leftBlow.y = 16;
			rightBlow.y = 16;
			leftBlow.visible = false;
			rightBlow.visible = false;
		}
		
		override public function update():void
		{
			if (Input.check(Key.LEFT))
			{
				// move right by speeding up
				xVel += xAccel * FP.elapsed;
				if ( xVel > 300 )
					xVel = 300;
				rightBlow.visible = true;
				leftBlow.visible = false;
			}
			else
			if (Input.check(Key.RIGHT))
			{
				// move left by slowing down and reversing direction
				xVel -= xAccel * FP.elapsed;
				if ( xVel < -300 )
					xVel = -300;
				rightBlow.visible = false;
				leftBlow.visible = true;
			}
			else
			{	
				// ease back to the middle
				if( xVel > 0 )
					xVel -= xAccel * FP.elapsed;
				else if ( xVel < 0 )
					xVel += xAccel * FP.elapsed;
				if ( xVel > 300 )
					xVel = 300;
				if ( xVel < -300 )
					xVel = -300;
				
				rightBlow.visible = false;
				leftBlow.visible = false;				
			}
			x += xVel * FP.elapsed;
			if (x < 96)
			{
				x = 96;
				xVel = 0;
			}
			if (x > FP.screen.width - 8 - 96)
			{
				x = FP.screen.width - 8 - 96;
				xVel = 0;
			}
			
			if (state == "move")
			{
				yVel += yAccel * FP.elapsed;
				yInc = yVel * FP.elapsed;
				y += yInc;
				if (yInc > 7.4)
					yInc = 7.4;
				leftCloud.y += yVel * FP.elapsed;
				rightCloud.y += yVel * FP.elapsed;
				leftBlow.y += yVel * FP.elapsed;
				rightBlow.y += yVel * FP.elapsed;
				score++;
			}
		}
		
	}

}